/*
 *	libetm / str_mem.h - Copyright (C) Emmanuel Thomas-Maurin 2008-2024
 *	<manutm007@gmail.com>
 *
 *	- A few strings and memory management functions -
 *
 *	This program is free software: you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation, either version 3 of the License, or
 *	(at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef INC_LIBETM_STR_MEM_H
#define INC_LIBETM_STR_MEM_H

char		*str_n_cpy(char *, const char *, size_t);

char		*str_n_cat(char *, const char *, size_t);

char		*l_str_new(const char *str);

char		*l_str_cat(char *, const char *);

char		*l_str_insert_at_b(char *, const char *);

void		l_str_free(char *);

void		*malloc2(size_t);

void		*realloc2(void *, size_t);

void		*calloc2(size_t, size_t);

void		free2(void *);

const char	*readable_size(double);

const char	*itoa2(long int);

char		*remove_char_from_str(char *, char);

char		*remove_leading_whitespaces_from_str(char *);

char		*remove_trailing_whitespaces_from_str(char *);

char		*remove_surrounding_whitespaces_from_str(char *);

zboolean	str_is_num(const char *);

zboolean	str_is_blank(const char *);

const char	*rnd_str(char, int);

#endif /* INC_LIBETM_STR_MEM_H */
