/*
 *	LibGame - Copyright (C) Emmanuel Thomas-Maurin 2011-2025
 *	All rights reserved
 */

#ifndef LG_CAM_CONTROLS_H
#define LG_CAM_CONTROLS_H

/**
 * Useful to fine tune the UI
 */
typedef struct {
	/* Also in LG_InputState */
	float		move_forward;
	float		move_up;
	float		cam_truck;
	float		yaw;
	float		pitch;
	float		roll;
	float		h_orbit;
	float		v_orbit;
	float		dz_wheel;
	zboolean	slow_motion;
	/* Not in LG_InputState */
	char		rotations_order[4];	/* One of "XYZ", "XZY", "YXZ", "YZX", "ZXY", "ZYX" */
	char		attitude_seq[13];	/* One of "PitchYawRoll", "PitchRollYaw", "YawPitchRoll", "YawRollPitch", "RollPitchYaw", "RollYawPitch" */
} LG_Camera_K;

zboolean	lg_camera_apply_in(LG_Camera *, LG_Camera_K *);

const char	*lg_rotations_order_from_yaw_pitch_roll(const char *);

#endif /* LG_CAM_CONTROLS_H */
