/*
 *	LibGame - Copyright (C) Emmanuel Thomas-Maurin 2011-2025
 *	All rights reserved
 */

#ifndef LG_DIRS_STUFF_H
#define LG_DIRS_STUFF_H

#define IMAGES_DIR		"images"

#define SOUNDS_DIR		"sounds"

#define MUSIC_DIR		"music"

#define FONTS_DIR		"fonts"

#define ENGINE_FONTS_DIR	"LG_assets/fonts"	/* Game engine preloaded fonts */

#define MESHES_DIR		"meshes"

#define SHADERS_DIR		"shaders"

#define ENGINE_SHADERS_DIR	"LG_assets/shaders"	/* Game engine provided shaders */

const char	*lg_img(const char *);

const char	*lg_snd(const char *);

const char	*lg_mus(const char *);

const char	*lg_fnt(const char *);

const char	*lg_engine_fnt(const char *);

const char	*lg_mesh(const char *);

const char	*lg_shader(const char *);

const char	*lg_engine_shader(const char *);

const char	*lg_assets_file(const char *, const char *);

const char	*lg_app_wr_file(const char *);

void		lg_assets_file_free_buffer();

#endif /* LG_DIRS_STUFF_H */
