/*
 *	LibGame - Copyright (C) Emmanuel Thomas-Maurin 2011-2025
 *	All rights reserved
 */

#ifndef LG_KEYBOARD_H
#define LG_KEYBOARD_H

#define LG_N_KEYS_MAX	4

#define AKM_LEFT	0x00000001U	/* ((uint8_t) 1) */
#define AKM_RIGHT	0x00000002U	/* ((uint8_t) 2) */
#define AKM_UP		0x00000004U	/* ((uint8_t) 4) */
#define AKM_DOWN	0x00000008U	/* ((uint8_t) 8) */

uint8_t		lg_get_special_keys_state(uint32_t *);

void		lg_get_motion_and_shot_from_keyboard(int *, int *, zboolean *, uint32_t *);

void		lg_wait_for_key_pressed(uint32_t);

uint32_t	lg_wait_for_key_from_set_pressed(int, uint32_t [LG_N_KEYS_MAX]);

uint32_t	lg_wait_for_any_key_pressed();

uint32_t	lg_return_key_pressed();

void		lg_flush_keyb_events();

#endif /* LG_KEYBOARD_H */
