/*
 *	LibGame - Copyright (C) Emmanuel Thomas-Maurin 2011-2025
 *	All rights reserved
 */

#ifndef LG_MATH_EXTRA_H
#define LG_MATH_EXTRA_H

typedef struct {
	float	x;
	float	y;
	float	z;
	float	w;
} vec4_t;

typedef struct {
	vec3_t	orig;
	vec3_t	dir;
} LG_Ray;

zboolean	lg_raycast_bsphere(LG_Camera *, LG_BSphere, float *);

vec4_t		vec4(float, float, float, float);

vec4_t		m4_mul_v4(mat4_t, vec4_t);

float		m4_det(mat4_t);

mat4_t		m4_invert(mat4_t);

#endif /* LG_MATH_EXTRA_H */
