/*
 *	LibGame - Copyright (C) Emmanuel Thomas-Maurin 2011-2025
 *	All rights reserved
 */

#ifndef LG_PART_SYS_H
#define LG_PART_SYS_H

/* Particles system */

/* Speed is a scalar whereas velocity is a vec3 */

typedef struct {
	vec3_t		center;
	Rec2Df		rec2d;
	LG_Texture	*tex;
	vec3_t		velocity;
	LG_Color_u	color;
	uint32_t	time;
	uint32_t	full_time;
} LG_Particle;

LG_Particle	lg_particle(vec3_t, Rec2Df, LG_Texture *, vec3_t, LG_Color_u, uint32_t, uint32_t);

#endif /* LG_PART_SYS_H */
