/*
 *	LibGame - Copyright (C) Emmanuel Thomas-Maurin 2011-2025
 *	All rights reserved
 */

#ifndef LG_SCENE_H
#define LG_SCENE_H

/* LG_Scene is defined in lg_scene_graph.h */
/*
typedef struct {
	int		id;	// Set to -1 on error=
	LG_Camera	*cam1;
	LG_Light	light1;
	Rec2Df		landscape_rec;
	LG_SceneNode	*root;
	LG_SceneNode	*grid;
	LG_SceneNode	*xyz_arrows;
} LG_Scene;
*/

/* Standard arrow colors = RGB, alternate colors = purple, green, cyan */
#define STANDARD_ARROW_COLORS	FALSE

/*
 * NTOS stands for Name and TOS (Transl/Orientation/Scaling)
 */
typedef struct {
	const char	*name;
	float		x_t;
	float		y_t;
	float		z_t;
	double		x_q;
	double		y_q;
	double		z_q;
	double		w_q;
	float		x_s;
	float		y_s;
	float		z_s;
} LG_Mesh_NTOS;

/* Scene description */
typedef struct {
	int			id;
	LG_Camera		*cam1;
	LG_Light		light1;
	Rec2Df			landscape_rec;
	LG_SceneNode		*root;
	LG_SceneNode		*grid;
	LG_SceneNode		*xyz_arrows;
	LG_SceneNode		*first_obj_node;
} LG_Scene_Des;

LG_Scene			lg_scene_new(int, LG_Camera *, LG_Light, Rec2Df, uint16_t);

void				lg_scene_free(LG_Scene *);

LG_SceneNode			*lg_scenenode_new_and_set(int, LG_SceneNode *, const char *, LG_LoadMesh_Flags, vec3_t, LG_Quat, vec3_t);

LG_SceneNode			*lg_mesh_NTOS_array_to_scenenodes(LG_SceneNode *, LG_LoadMesh_Flags, LG_Mesh_NTOS *, int);

mat4_t				lg_TOS_to_matrix(vec3_t, LG_Quat, vec3_t);

void				lg_mesh_NTOS_array_info(LG_Mesh_NTOS *, int);

#define transl_v3(x, y, z)	vec3(x, y, z)

#define scaling_v3(x, y, z)	vec3(x, y, z)

#endif /* LG_SCENE_H */
