/*
 *	LibGame - Copyright (C) Emmanuel Thomas-Maurin 2011-2025
 *	All rights reserved
 */

#ifndef LG_STRING_H
#define LG_STRING_H

#define LG_STRING_MAX_LEN	4096			/* Is this making sense ? */
#define LG_STRING_SIG		"LG_String"
#define LG_STRING_SIG_LEN	9

#define LG_STRING_DATA_MAX_LEN	(512 - 1)

typedef struct LG_String LG_String;

struct LG_String {
	const char	*data;				/* Most probably some text */
	uint32_t	size;				/* Doesn't include terminating NULL */
	LG_String	*prev;
	LG_String	*next;
	uint8_t		sig[LG_STRING_SIG_LEN];		/* Not NULL-terminated */
};

/* Kind of 'expanded' LG_String */
typedef struct {
	LG_String	*lg_string;
	char		data[LG_STRING_DATA_MAX_LEN + 1];
} LG_String_Data;

LG_String	*lg_string_get_root();

zboolean	is_lg_string(LG_String *);

LG_String	*lg_string_new(const char *);

const char	*lg_string_get_data(LG_String *);

void		lg_string_remove(LG_String *);

void		lg_string_remove_all();

int		lg_string_count(uint32_t *);

zboolean 	lgstring_array_to_lgstringdata_array(LG_String_Data *[], const LG_String *[], uint32_t);

zboolean	lgstringdata_array_to_lgstring_array(LG_String *[], const LG_String_Data *[], uint32_t);

void		lg_string_info(LG_String *);

#endif /* LG_STRING_H */
